/* vi: set tabstop=4 paste nocindent noautoindent: */

#ifndef  __JBXL_TINY_LIST_H_
#define  __JBXL_TINY_LIST_H_


/** 
@brief   Tiny List \Cuwb_
@file    tlist.h
@version
@author  Fumi.Iseki (C)
@date    2008 2/1
@see     tList (_tList)
*/



#include "buffer.h"



struct  _tList_data;
struct  _tList;



struct  _tList_data {
	int	 	id;					///< m[hID
	int	 	lv;					///< m[hlij
	Buffer  key;				///< m[h̃L[
	Buffer  val;				///< m[hlij
	void*	ptr;				///< ėpi\̂Ȃǁj
	int	 	sz;					///< *ptr̃TCY
	struct _tList* 	lst;		///< Xgf[^ւ̃|C^
};


/** 
typedef  struct _tList_data 	tList_data;

@code
tList_data \
	int	 	id;				m[hID
	int	 	lv;				m[hlij
	Buffer  key;			m[h̃L[
	Buffer  val;			m[hlij
	void*	ptr;			ėpD\̂Ȃǂւ̃|C^Diptr->X  freełȂ̂ŃXĝ悤ȃ|C^ݒ肵Ă͂Ȃj
	int	 	sz;				*ptr ̃TCY
	struct _tList* 	lst;	Xgf[^ւ̃|C^
@endcode
*/
typedef  struct _tList_data tList_data;



struct  _tList {
	struct _tList_data	ldat;	///< f[^

	struct _tList* 		next;	///< qm[hւ̃|C^
	struct _tList* 		prev;	///< em[hւ̃|C^
	struct _tList* 		altp;	///< ̃m[hւ̃|C^

	struct _tList* 		back;	///< qiqjm[hւ̃|C^  for tTree
	struct _tList* 		esis;	///< O̎om[hւ̃|C^      for tTree
	struct _tList* 		ysis;	///< ̎om[hւ̃|C^      for tTree

	int 				depth;	///< [                            for tTree
	int 				num;	///< qm[h̐                    for tTree
	int 				ctrl;	///< p                          for tTree
	int					state;	///< m[h̏
};


/** 
typedef  struct _tList 	tList;

@code
tList \
	tList_data 	ldat	f[^

	tList*	 	next	qm[hւ̃|C^
	tList*	 	prev	em[hւ̃|C^
	tList*		altp	̃m[hւ̃|C^

	tList*		back	qiqjm[hւ̃|C^  for tTree
	tList*		esis	O̎om[hւ̃|C^      for tTree
	tList*		ysis	̎om[hւ̃|C^      for tTree

	int 		depth	[                            for tTree
	int			num		qm[h̐                    for tTree
	int			ctrl	p                          for tTree
	int			state   m[h̏
@endcode
 */
typedef  struct _tList  tList;



// Anchor Node
#define	LIST_ANCHOR		"LIST_ANCHOR"


// for strncmp_tList()
#define TLIST_MATCH_COMPLETE	0	
#define TLIST_MATCH_TLISTKEY	-1		
#define TLIST_MATCH_STRINGKEY 	-2		
#define TLIST_MATCH_STRKEY 		-2		




/**/
////////////////////////////////////////////////////////////////////////////////////////////////////
//
// List Data
//

tList_data  init_tListdata(void);

tList_data  make_tListdata      (int id, int lv, Buffer key, Buffer val, void* ptr, int sz);
tList_data  make_tListdata_bystr(int id, int lv, char*  key, char*  val, void* ptr, int sz);
#define  	make_tListdata_byBuffer(i, l, k, v, d, s)	make_tListdata((i), (l), (k), (v), (d), (s))

#define  	make_tListdata_int(k, v)		make_tListdata_bystr((k), (v), NULL, NULL, NULL, 0)
#define  	make_tListdata_str(k, v)		make_tListdata_bystr(0, 0, (char*)(k), (char*)(v), NULL, 0)
#define  	make_tListdata_Buffer(k, v)		make_tListdata(0, 0, (k), (v), NULL, 0)

tList_data	dup_tListdata (tList_data ldat);
void   		free_tListdata(tList_data* ldat);





////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Tiny List Node
//

tList*  new_tList_node(void);
tList  	make_tList_node(tList_data data);

// ǉ new_tList_node() gp
tList*  add_tList_node_bydata  (tList* pp, tList_data ldat); 
tList*  add_tList_node_bystr   (tList* pp, int id, int lv, char*  key, char*  val, void* ptr, int sz);
tList*  add_tList_node_byBuffer(tList* pp, int id, int lv, Buffer key, Buffer val, void* ptr, int sz); 
#define add_tList_node_int(p, k, v)  			add_tList_node_bystr((p), (k), (v), NULL, NULL, NULL, 0)
#define add_tList_node_str(p, k, v)  			add_tList_node_bystr((p), 0, 0, (char*)(k), (char*)(v), NULL, 0)
#define add_tList_node_null(p)					add_tList_node_bystr((p), 0, 0, NULL, NULL, NULL, 0)
#define add_tList_node_Buffer(p, k, v)			add_tList_node_byBuffer((p), 0, 0, (k), (v), NULL, 0)

#define insert_tList_node(p, t)					insert_tList((p), (t))


// ݒ
void	set_tList_node_bydata  (tList* pp, tList_data ldat);
void	set_tList_node_bystr   (tList* pp, int id, int lv, char*  key, char*  val, void* ptr, int sz);
void	set_tList_node_byBuffer(tList* pp, int id, int lv, Buffer key, Buffer val, void* ptr, int sz);
#define set_tList_node_int(p, k, v) 	 		set_tList_node_bystr((p), (k), (v), NULL, NULL, NULL, 0)
#define set_tList_node_str(p, k, v)  			set_tList_node_bystr((p), 0, 0, (char*)(k), (char*)(v), NULL, 0)
#define set_tList_node_Buffer(p, k, v)			set_tList_node_byBuffer((p), 0, 0, (k), (v), NULL, 0)

// čXVDΒǉDiǉ new_tList_node()gpj
tList*	update_tList_node		  (tList* pp, tList* pt);
tList*	update_tList_node_bydata  (tList* pp, char* key, tList_data ldat);
tList*	update_tList_node_bystr   (tList* pp, int id, int lv, char*  key, char*  val, void* ptr, int sz);
tList*	update_tList_node_byBuffer(tList* pp, int id, int lv, Buffer key, Buffer val, void* ptr, int sz);
#define update_tList_node_int(p, k, v)  		update_tList_node_bystr((p), (k), (v), NULL, NULL, NULL, 0)
#define update_tList_node_str(p, k, v)	  		update_tList_node_bystr((p), 0, 0, (char*)(k), (char*)(v), NULL, 0)
#define update_tList_node_Buffer(p, k, v)		update_tList_node_byBuffer((p), 0, 0, (k), (v), NULL, 0)


tList*  del_tList_node (tList* node); 
tList*  dup_tList_node (tList* node);
tList*  move_tList_node(tList* node, tList* pp); 
void  	free_tList_node(tList** node); 




////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Tiny List
//

tList*  add_tList_end(tList* pp, tList* pt);
tList*  insert_tList(tList* pp, tList* pt); 
tList*  dup_tList(tList* pp);
void   	print_tList(FILE* fp, tList* pp);
void   	dump_tList(FILE* fp, tList* pp);
int		count_tList(tList* pp);

tList*  del_tList(tList** pp); 
void   	del_all_tList(tList** pp);
int  	del_tList_key(tList** pp, char* key, int no);
#define free_tList(l)   del_tList(l)

tList*  find_tList_top(tList* pp); 
tList*  find_tList_end(tList* pp); 


//   Xgւ̃|C^Ԃ 
//		len: 1ȏ:v钷C0:SvC-1:pl->key̒ɍ킹C-2:key̒ɍ킹
tList*  strncmp_tList   (tList* pl, char*  key, int len, int no);
tList*  strnrvscmp_tList(tList* pl, char*  key, int len, int no);
tList*  strstr_tList    (tList* pl, char*  key, int len, int no);

tList*  strncasecmp_tList   (tList* pl, char*  key, int len, int no);
tList*  strncaservscmp_tList(tList* pl, char*  key, int len, int no);
tList*  strstrcase_tList    (tList* pl, char*  key, int len, int no);


tList*  strncmp_back_tList   (tList* pl, char*  key, int len, int no);
tList*  strnrvscmp_back_tList(tList* pl, char*  key, int len, int no);
tList*  strstr_back_tList    (tList* pl, char*  key, int len, int no);

tList*  strncasecmp_back_tList   (tList* pl, char*  key, int len, int no);
tList*  strncaservscmp_back_tList(tList* pl, char*  key, int len, int no);
tList*  strstrcase_back_tList    (tList* pl, char*  key, int len, int no);


// Xg̍폜


// @ldat.val ̃Rs[Ԃ 
Buffer  search_key_tList(tList* lt, char* key, int no);
Buffer  search_key_value_tList(tList* lt, char* key, char* data, int no);


// Tools
tList*	awk_tList (char* str, char cc);
tList*	cawk_tList(char* str, char cc);
tList*	awk_Buffer_tList (Buffer buf, char cc);
tList*	cawk_Buffer_tList(Buffer buf, char cc);
char*   get_str_join_tList(tList* lp, char* deli);				// v free
Buffer  get_Buffer_join_tList(tList* lp, char* deli);


// lύX
int     set_value_tList(tList* lt, char* key, int no, char* value, int mode);
int     replace_value_tList(tList* lt, char* key, int no, char* srcval, char* value);

int     set_value_tList_node(tList* lt, char* value);
int     replace_value_tList_node(tList* lt, char* srcval, char* value);



// for Configuration File
char* 	get_str_param_tList   (tList* lt, char* key, const char* dflt);
int  	get_int_param_tList   (tList* lt, char* key, int dflt);
double  get_double_param_tList(tList* lt, char* key, double dflt);
float   get_float_param_tList (tList* lt, char* key, float dflt);
int     get_bool_param_tList  (tList* lt, char* key, int dflt);

#define get_strparam_tList(l, k, d) 	get_str_param_tList((l), (k), (d))
#define get_intparam_tList(l, k, d) 	get_int_param_tList((l), (k), (d))
#define get_doubleparam_tList(l, k, d) get_double_param_tList((l), (k), (d)) 
#define get_boolparam_tList(l, k, d) 	get_bool_param_tList((l), (k), (d))


////////////////////////////////////////////////////////////////////////////////////////////////////
//
// File I/O with Tiny List
//

tList*  read_tList_fp(FILE* fp, int mode);
tList*  read_tList_file(char* fn, int mode);
tList*  read_index_tList_fp(FILE* fp, char deli);
tList*  read_index_tList_file(char* fn, char deli);

tList*  read_Buffer_tList_fp(FILE* fp);
tList*  read_Buffer_tList_file(char* fn);
int  	save_Buffer_tList_fp(FILE* fp, tList* lt);
int		save_Buffer_tList_file(char* fn, tList* lt);



/**/


#endif


