/* vim: set tabstop=4 paste nocindent noautoindent ff=unix: */


/**
@brief   ėpc[vO
@file    tools.c
@author  Fumi.Iseki (C)
@date    2005 10/10
*/



#include "tools.h"



int   DebugMode 	= OFF;
int	  UnitTestMode 	= OFF;

int   KanjiCode 	= CODE_EUC;						///< VXe̊R[h
int   HostEndian 	= UNKNOWN_ENDIAN;				///< VXe Endian

char  LocalIPNum[4] = {0x7f, 0x00, 0x00, 0x01};		///< 127.0.0.1 ̃oCi






///////////////////////////////////////////////////////////////////////////////////////////
// 

// case of C++, isNull() is inline

#ifndef CPLUSPLUS

/**
int  isNull(void* p)

|C^ NULLǂD@n
Windows̏ꍇC|C^oD

@param  p     |C^D

@retval TRUE  |C^NULLC܂͖iWindows̏ꍇj
@retval FALSE |C^NULLł͂ȂLiWindows̏ꍇjłD

@attention
JunkBox_LIb++ ̏ꍇ͂̊֐ł͂ȂCinline^ isNull() gpD
*/
int  isNull(void* p)
{
	if (p==NULL) return TRUE;

#ifdef WIN32
	if (p==WIN32_NULL) return TRUE;
#endif
#ifdef WIN64
	if (p==WIN64_NULL) return TRUE;
#endif
	return FALSE;
}

#endif






///////////////////////////////////////////////////////////////////////////////////////////
// 

/**
int is_little_endian(void)

GfBA̓I`FbN

xĂяoƁCϐ @b HostEndian  @b LITTLE_ENDIAN  @b BIG_ENDIAN ݒ肳D

@retval TRUE   Little Endian
@retval FALSE  Big Endian

@see HostEndian, is_big_endian()
*/
int is_little_endian(void)
{
	unsigned char x[] = {0x01, 0x00};

	if (HostEndian==LITTLE_ENDIAN) return TRUE;

	else if (HostEndian==BIG_ENDIAN) return FALSE;

	else {
		if (*((unsigned short*)x)==1) {
			HostEndian = LITTLE_ENDIAN;
			return TRUE;
		}
		else {
			HostEndian = BIG_ENDIAN;
			return FALSE;
		}
	}
}



/**
int is_big_endian(void)

GfBA̓I`FbN

xĂяoƁCϐ @b HostEndian  @b LITTLE_ENDIAN  @b BIG_ENDIAN ݒ肳D

@retval TRUE   Big Endian
@retval FALSE  Little Endian

@see HostEndian, is_little_endian()
*/
int is_big_endian(void)
{
	unsigned char x[] = {0x00, 0x01};

	if (HostEndian==BIG_ENDIAN) return TRUE;

	else if (HostEndian==LITTLE_ENDIAN) return FALSE;

	else {
		if (*((unsigned short*)x)==1) {
			HostEndian = BIG_ENDIAN;
			return TRUE;
		}
		else {
			HostEndian = LITTLE_ENDIAN;
			return FALSE;
		}
	}
}



/**
void  check_endian(void)

ϐ @b HostEndian  @b LITTLE_ENDIAN  @b BIG_ENDIAN ݒ肷D

@see HostEndian
*/
void  check_endian(void)
{
	if (HostEndian==UNKNOWN_ENDIAN) is_little_endian();
} 



/** double double_from_little_endian(void* ptr)

Little Endian`Ŋi[Ă double^̒loD

@param  ptr  ϐi[Ă郁ւ̃|C^
@return o double^̒l
*/
double double_from_little_endian(void* ptr)
{
	double ret = *((double*)ptr);
	
	if (HostEndian==UNKNOWN_ENDIAN) check_endian();
	if (HostEndian==BIG_ENDIAN) reverse_str((uByte*)(&ret), 8);
	return ret;
}



/**
float float_from_little_endian(void* ptr)

Little Endian`Ŋi[Ă float^̒loD

@param  ptr  ϐi[Ă郁ւ̃|C^
@return o float^̒l
*/
float float_from_little_endian(void* ptr)
{
	float ret = *((float*)ptr);

	if (HostEndian==UNKNOWN_ENDIAN) check_endian();
	if (HostEndian==BIG_ENDIAN) reverse_str((uByte*)(&ret), 4);
	return ret;
}



/**
int  int_from_little_endian(void* ptr)

Little Endian`Ŋi[Ă int^̒loD

@param  ptr  ϐi[Ă郁ւ̃|C^
@return o int^̒l
*/
int  int_from_little_endian(void* ptr)
{
	int ret = *((int*)ptr);

	if (HostEndian==UNKNOWN_ENDIAN) check_endian();
	if (HostEndian==BIG_ENDIAN) reverse_str((uByte*)(&ret), 4);
	return ret;
}



/**
short short_from_little_endian(void* ptr)

Little Endian`Ŋi[Ă short int^̒loD

@param  ptr  ϐi[Ă郁ւ̃|C^
@return o short int^̒l
*/
short short_from_little_endian(void* ptr)
{
	short ret = *((short*)ptr);

	if (HostEndian==UNKNOWN_ENDIAN) check_endian();
	if (HostEndian==BIG_ENDIAN) reverse_str((uByte*)(&ret), 2);
	return ret;
}



/**
double double_from_big_endian(void* ptr)

Big Endian`Ŋi[Ă double^̒loD

@param  ptr  ϐi[Ă郁ւ̃|C^
@return o double^̒l
*/
double double_from_big_endian(void* ptr)
{
	double ret = *((double*)ptr);

	if (HostEndian==UNKNOWN_ENDIAN) check_endian();
	if (HostEndian==LITTLE_ENDIAN) reverse_str((uByte*)(&ret), 8);
	return ret;
}



/**
float float_from_big_endian(void* ptr)

Big Endian`Ŋi[Ă float^̒loD

@param  ptr  ϐi[Ă郁ւ̃|C^
@return o float^̒l
*/
float float_from_big_endian(void* ptr)
{
	float ret = *((float*)ptr);

	if (HostEndian==UNKNOWN_ENDIAN) check_endian();
	if (HostEndian==LITTLE_ENDIAN) reverse_str((uByte*)(&ret), 4);
	return ret;
}



/**
int  int_from_big_endian(void* ptr)

Big Endian`Ŋi[Ă int^̒loD

@param  ptr  ϐi[Ă郁ւ̃|C^
@return o int^̒l
*/
int  int_from_big_endian(void* ptr)
{
	int ret = *((int*)ptr);

	if (HostEndian==UNKNOWN_ENDIAN) check_endian();
	if (HostEndian==LITTLE_ENDIAN) reverse_str((uByte*)(&ret), 4);
	return ret;
}



/**
short short_from_big_endian(void* ptr)

Big Endian`Ŋi[Ă short int^̒loD

@param  ptr  ϐi[Ă郁ւ̃|C^
@return o short int^̒l
*/
short short_from_big_endian(void* ptr)
{
	short ret = *((short*)ptr);

	if (HostEndian==UNKNOWN_ENDIAN) check_endian();
	if (HostEndian==LITTLE_ENDIAN) reverse_str((uByte*)(&ret), 2);
	return ret;
}




///////////////////////////////////////////////////////////////////////////////////////////
// Time

char  _Local_Time[32];		///< Ɨpi[J^Cj

/**
char*  get_local_time(void)

[J^C "N:: ::b" ̌`ŕԂD
ԂĂ char* |C^ freeĂ͂Ȃ.

@return "N:: ::b" `̃[J^C
*/
char*  get_local_time(void)
{
    struct tm* pt;
    time_t tm;

    tm = time(NULL);
    pt = localtime(&tm);

	snprintf(_Local_Time, 20, "%04d:%02d:%02d %02d:%02d:%02d", pt->tm_year+1900, pt->tm_mon+1, pt->tm_mday, pt->tm_hour, pt->tm_min, pt->tm_sec);

	return _Local_Time;
}




///////////////////////////////////////////////////////////////////////////////////////////

/**
char*  get_line(char* buf, int n)

^f[^str̃obt@ nsڂoDsR[h͍폜D

os char^ϐ̃obt@Ɋi[ĕԂD@n
obt@̍Ōオ '\0' ŏIĂꍇCobt@zčsǂƂꍇ NULL ԂD@n
'\0' ŏIĂȂꍇCobt@ŏI肩m鎖́iȒPȕ@ł́jłȂD

Ԃꂽf[^ free()KvD

@param  buf  Ώە̎^f[^(܂މs)
@param  n    s̎wD1 琔D
@return      w肳ꂽ nsڂ̕Ds͊܂܂ȂDv free
*/
char*  get_line(char* buf, int n)
{
	int   i, j, pos, cnt;
	char* ret = NULL;

	if (buf==NULL) return NULL;

	for(i=0,j=0; j<n-1; j++) {
		while (buf[i]!=CHAR_LF && buf[i]!=CHAR_CR && buf[i]!='\0') i++;
		while (buf[i]==CHAR_LF || buf[i]==CHAR_CR) i++;
	}
	if (buf[i]=='\0') return  NULL;

	pos = i;
	while (buf[i]!=CHAR_LF && buf[i]!=CHAR_CR && buf[i]!='\0') i++;
	cnt = i - pos;

	if (cnt>=0) {  
		ret = (char*)malloc(cnt+1);
		if (ret==NULL) return NULL;

		for(i=0; i<cnt; i++) ret[i] = buf[pos+i];
		ret[cnt] = '\0';
	}
	return  ret;
}




/**
char*  get_seq_data(char* buf, int* ptr)

^f[^ buf̃obt@̍sf[^V[PVɎoD

sR[h͍폜DAČĂяoꍇCԍŏ *ptr 0ݒ肵CȌ *ptr̓e͕ςȂD 
os char^ϐ̃obt@Ɋi[ĕԂD@n
obt@̍Ōオ '\0' ŏIĂꍇCobt@zčsǂƂ NULL ԂD
'\0' ŏIĂȂꍇCobt@ŏI肩m鎖́iȒPȕ@ł́jłȂD

Ԃꂽf[^ free()KvD

@param[in]      buf  Ώە̎^f[^(܂މs)
@param[in,out]  ptr  in: ǂݍ݂Jnf[^̈ʒuioCgjDout: ̃f[^n܂ʒuioCgjD 
@return              w肳ꂽ|C^ȉ̈s̕Ds͊܂܂ȂDv free
*/
char*  get_seq_data(char* buf, int* ptr)
{
	int   pos, cnt;
	char* ret = NULL;

	if (buf==NULL || buf[*ptr]=='\0') return NULL;

	pos = *ptr;
	while (buf[*ptr]!=CHAR_LF && buf[*ptr]!=CHAR_CR && buf[*ptr]!='\0') (*ptr)++;
	cnt = *ptr - pos;

	if (cnt>=0) {  
		ret = (char*)malloc(cnt+1);
		if (ret==NULL) return NULL;

		int i;
		for(i=0; i<cnt; i++) ret[i] = buf[pos+i];
		ret[cnt] = '\0';
	}

	while (buf[*ptr]==CHAR_LF || buf[*ptr]==CHAR_CR) (*ptr)++;
	return  ret;
}




/**
char*  awk(char* buf, char cc, int n)

cc؂LƂ, str̃obt@ nԖڂ̍ڂԂD
Ԃꂽf[^ free()KvD

@param  buf  ΏەD
@param  cc   ؂蕶D
@param  n    ڂ̎wD 1琔D

@return w肳ꂽ nԖڂ̍ڂ̕Dv free
@see cawk()
*/
char*  awk(char* buf, char cc, int n)
{
	int i, j, pos, cnt;
	char*  item = NULL;

	if (buf==NULL) return NULL;

	for(i=0,j=0; j<n-1; j++) {
		while (buf[i]!='\0' && buf[i]!=cc) i++;
		if (buf[i]==cc) i++;
	}
	if (buf[i]=='\0')  return NULL;

	pos = i;
	while (buf[i]!='\0' && buf[i]!=cc) i++;
	cnt = i - pos;

	item = (char*)malloc(cnt+1);
	if (item==NULL) return NULL;

	for (i=0; i<cnt; i++) item[i] = buf[pos+i];
	item[cnt] = '\0';

	return item;
}




/**
char*  cawk(char* buf, char cc, int n)

cc؂LƂ, str̃obt@ nԖڂ̍ڂԂD

n  1琔DA cc(؂)͈̋؂Ƃ݂ȂD
Ԃꂽf[^ free()KvD

@param  buf  ΏەD
@param  cc   ؂蕶D
@param  n    ڂ̎wD

@return w肳ꂽ nԖڂ̍ڂ̕Dv free.
@see awk()
*/
char*  cawk(char* buf, char cc, int n)
{
	int i, j, pos, cnt;
	char*  item = NULL;

	if (buf==NULL) return NULL;

	for(i=0,j=0; j<n-1; j++) {
		while (buf[i]!='\0' && buf[i]!=cc) i++;
		while (buf[i]!='\0' && buf[i]==cc) i++;
	}
	if (buf[i]=='\0') return NULL;

	pos = i;
	while (buf[i]!='\0' && buf[i]!=cc) i++;
	cnt = i - pos;

	item = (char*)malloc(cnt+1);
	if (item==NULL) return NULL;

	for (i=0; i<cnt; i++) item[i] = buf[pos+i];
	item[cnt] = '\0';

	return item;
}




/**
int  bincmp(unsigned char* b1, unsigned char* b2, int n) 

oCif[^ s1 s2 noCgrD

@param  b1  roCif[^1
@param  b2  roCif[^2
@param  n   roCg

@retval 0   v
@retval 1   vȂ

@attention strncmp()̖߂l̒`Ƃ͎኱قȂ̂Œӂ邱ƁD
*/
int  bincmp(unsigned char* b1, unsigned char* b2, int n) 
{
	int i;

	if (b1==NULL || b2==NULL) return 1;

	for (i=0; i<n; i++) {
		if (b1[i]!=b2[i]) return 1;
	}

	return 0;
}




/**
int  strnrvscmp(const char* s1, const char* s2, int n) 

 s1 s2납 nrD

@retval 0  v
@retval 1  vȂ

@attention strncmp()̖߂l̒`Ƃ͎኱قȂ̂Œӂ邱ƁD
*/
int  strnrvscmp(const char* s1, const char* s2, int n) 
{
	int j1, j2;
	
	if (s1==NULL || s2==NULL) return 1;

	j1 = (int)strlen(s1) - 1;
	j2 = (int)strlen(s2) - 1;

	while (n>0 && j1>=0 && j2>=0) {
		if (s1[j1--] != s2[j2--]) return 1;
		n--;
	}

	if (n==0) return 0;
	else	  return 1;
}




/**
int  strncaservscmp(const char* s1, const char* s2, int n) 

 s1 s2납 nrD

@retval 0  v
@retval 1  vȂ

@attention strncmp()̖߂l̒`Ƃ͎኱قȂ̂Œӂ邱ƁD
*/
int  strncaservscmp(const char* s1, const char* s2, int n) 
{
	int j1, j2;
	
	if (s1==NULL || s2==NULL) return 1;

	j1 = (int)strlen(s1) - 1;
	j2 = (int)strlen(s2) - 1;

	while (n>0 && j1>=0 && j2>=0) {
		if (toupper(s1[j1--]) != toupper(s2[j2--])) return 1;
		n--;
	}

	if (n==0) return 0;
	else	  return 1;
}




/**
char*  strstrcase(const char* buf, const char* nd)

 buf̒ɕ nd邩ǂ`FbND啶ʂȂD	

啶ʂȂ_΁Cstrstr() ƓD@n
܂ strcasestr() ƓDW strcasestr()݂ȂꍇɎgpD

@param  buf  Ώۂ̕
@param  nd   镔
@return ̊Jnw|C^D񂪌Ȃꍇ NULL

@see strstr(), strcasestr()
*/
char*  strstrcase(const char* buf, const char* nd)
{
	char* pp;
	char* pb;
	char* pn;

	if (buf==NULL || nd==NULL) return NULL;

	pb = (char*)malloc(strlen(buf)+1);
	if (pb==NULL) return NULL;
	memcpy(pb, buf, (int)strlen(buf)+1);

	pn = (char*)malloc(strlen(nd)+1);
	if (pn==NULL) {
		free(pb);
		return NULL;
	}
	memcpy(pn, nd, (int)strlen(nd)+1);

	upper_string(pb);
	upper_string(pn);

	pp = strstr(pb, pn);
	if (pp!=NULL) {
		pp = (pp - pb) + (char*)buf;
	}
	free(pb);
	free(pn);

	return pp;
}




/**
int  ex_strncmp(const char* dat, const char* key, int len) 

gr

@param  dat   ׂ镶1D
@param  key   ׂ镶2D
@param  len    1ȏ: v钷D
@param  len    0:     SvD
@param  len   -1:     dat ̒ɍ킹D
@param  len   -2:     key ̒ɍ킹D
  
@retval TRUE  v
@retval FALSE vȂ
*/
int  ex_strncmp(const char* dat, const char* key, int len) 
{
	if (dat==NULL || key==NULL) return FALSE;

	if (len==0) {
		if (!strcmp(dat, key)) return TRUE;
	}
	else if (len>0) {
		if (!strncmp(dat, key, len)) return TRUE;
	}
	else if (len<0) {
		int sz;
		if (len==-1) sz = (int)strlen(dat);
		else		 sz = (int)strlen(key);
		if (!strncmp(dat, key, sz)) return TRUE;
	}
	
	return FALSE;
}




/**
int  ex_strncasecmp(const char* dat, const char* key, int len) 

grDP[XD

@param  dat   ׂ镶1D
@param  key   ׂ镶2D
@param  len    1ȏ: v钷D
@param  len    0:     SvD
@param  len   -1:     dat ̒ɍ킹D
@param  len   -2:     key ̒ɍ킹D
  
@retval TRUE  v
@retval FALSE vȂ
*/
int  ex_strncasecmp(const char* dat, const char* key, int len) 
{
	if (dat==NULL || key==NULL) return FALSE;

	if (len==0) {
		if (!strcasecmp(dat, key)) return TRUE;
	}
	else if (len>0) {
		if (!strncasecmp(dat, key, len)) return TRUE;
	}
	else if (len<0) {
		int sz;
		if (len==-1) sz = (int)strlen(dat);
		else		 sz = (int)strlen(key);
		if (!strncasecmp(dat, key, sz)) return TRUE;
	}
	
	return FALSE;
}




/** i
int  ex_strnrvscmp(const char* dat, const char* key, int len) 

grD납ׂD

@param  dat   ׂ镶1D
@param  key   ׂ镶2D
@param  len    1ȏ: v钷D
@param  len    0:     SvD
@param  len   -1:     dat ̒ɍ킹D
@param  len   -2:     key ̒ɍ킹D
   
@retval TRUE  v
@retval FALSE vȂ
*/
int  ex_strnrvscmp(const char* dat, const char* key, int len) 
{
	if (dat==NULL || key==NULL) return FALSE;

	if (len==0) {
		if (!strcmp(dat, key)) return TRUE;
	}
	else if (len>0) {
		if (!strnrvscmp(dat, key, len)) return TRUE;
	}
	else if (len<0) {
		int sz;
		if (len==-1) sz = (int)strlen(dat);
		else		 sz = (int)strlen(key);
		if (!strnrvscmp(dat, key, sz)) return TRUE;
	}
	
	return FALSE;
}




/**
int  ex_strncaervscmp(const char* dat, const char* key, int len) 

grD납ׂDP[XD

@param  dat   ׂ镶1D
@param  key   ׂ镶2D
@param  len    1ȏ: v钷D
@param  len    0:     SvD
@param  len   -1:     dat ̒ɍ킹D
@param  len   -2:     key ̒ɍ킹D

@retval TRUE  v
@retval FALSE vȂ
*/
int  ex_strncaservscmp(const char* dat, const char* key, int len) 
{
	if (dat==NULL || key==NULL) return FALSE;

	if (len==0) {
		if (!strcasecmp(dat, key)) return TRUE;
	}
	else if (len>0) {
		if (!strncaservscmp(dat, key, len)) return TRUE;
	}
	else if (len<0) {
		int sz;
		if (len==-1) sz = (int)strlen(dat);
		else		 sz = (int)strlen(key);
		if (!strncaservscmp(dat, key, sz)) return TRUE;
	}
	
	return FALSE;
}




/**
char*  chomp(char* buf)

ŏ̉sR[hȍ~𖳎Dŏ̉sR[ĥꏊ '\0' D

@param[in,out]  buf  s𖳌ɂ镶D
@return ꂽ buf[] ւ̃|C^D
*/
char*  chomp(char* buf)
{
	int i, len;
	
	if (buf==NULL) return NULL;

	len = (int)strlen(buf);
	for (i=0; i<len; i++) {
		if (buf[i]==CHAR_LF || buf[i]==CHAR_CR) {
			buf[i] = '\0';
			return buf;
		}
	}
	return buf;
}




/**
char*  skip_char(char* pm, const char* check)

pm̎w񒆂ŁCcheck[]Ɋi[ꂽꂩ̕܂Ń|C^XLbvD

@b " @b ' ɊYꍇCꂠ͖D

@param  pm     ̐擪|C^
@param	check  XLbv镶i[D
@return check[]̒ōŏɌւ̃|C^D
*/
char*  skip_char(char* pm, const char* check)
{
	int  n, sqf=0, dqf=0;

	n = (int)strlen(check);

	while (*pm!='\0') {
		if		(!sqf && *pm=='"')  dqf = 1 - dqf;
		else if (!dqf && *pm=='\'') sqf = 1 - sqf;

		else if (!sqf && !dqf) {
			int i;
			for (i=0; i<n; i++) {
				if (*pm==check[i]) return pm;
			}
		}
		pm++;
	}

	return NULL;
}




/**
char*  pack_head_tail_char(char* mesg, char cc)

̐擪cc()CIcc()CTAB, CR, LF 폜

̐擪CI蕔łȂꏊɂ cc͍폜ȂD
Ԃꂽf[^ free()KvD

@param  mesg  Ώۂ̕
@param  cc    폜镶
@return ϊ̕Dv free
*/
char*  pack_head_tail_char(char* mesg, char cc)
{
	int   sz;
	char* ps;
	char* pe;
	char* pp;

	if (mesg==NULL) return NULL;

	ps = mesg;
	while(*ps==cc || *ps==CHAR_TAB || *ps==CHAR_LF || *ps==CHAR_CR) ps++;
	pe = ps;
	while(*pe!='\0') pe++;
	pe--;
	while(*pe==cc || *pe==CHAR_TAB || *pe==CHAR_LF || *pe==CHAR_CR) pe--;

	sz = (int)(pe - ps) + 1;
	pp = (char*)malloc((size_t)(sz + 1));
	memcpy(pp, ps, sz);
	pp[sz] = '\0';

	return pp;		
}




/**
char*  pack_char(char* mesg, char cc)

񒆋yсC擪cc()CIcc()CCR, LF 폜

^u͋󔒂ɕϊDbZ[W̘A cc  1ɕϊD
Ԃꂽf[^ free()KvD

CR, LF 폜iĵŒӁD

@param  mesg  Ώۂ̕
@param  cc    폜镶
@return ϊ̕Dv free
*/
char*  pack_char(char* mesg, char cc)
{
	int i, j;
	int sf = OFF;	// A cc p̃tO
	int ff = ON; 	// 擪 cc 𖳎邽߂̃tO
	char* pp;

	if (mesg==NULL) return NULL;

	pp = (char*)malloc(strlen(mesg)+1);
	if (pp==NULL) return NULL;

	i = j = 0;
	while(mesg[i]!='\0') {
		if (mesg[i]==CHAR_TAB)  mesg[i] = ' ';
		if (mesg[i]!=CHAR_CR && mesg[i]!=CHAR_LF) {		// CR LF ǂݔ΂D
			if (mesg[i]==cc) {
				if (sf==OFF) {
					sf = ON;
					if (ff==ON) ff = OFF;
					else  pp[j++] = mesg[i];
				}
			}
			else {
				sf = ff = OFF;
				pp[j++] = mesg[i];
			}
		}
		i++;
	}
	pp[j] = '\0';

	//  cc 폜
	i = (int)strlen(pp) - 1;
	while(i>=0) {
		if (pp[i]==cc) i--; 
		else  break;
	}
	pp[i+1] = '\0';

	return pp;
}




/**
char*  change_esc(char* mesg)

񒆂 CR, LF  @\r, @\n ɕϊD
Ԃꂽf[^ free()KvD

@param  mesg  Ώۂ̕
@return ϊ̕Dv free
*/
char*  change_esc(char* mesg)
{
	int i, j;
	char* pp;

	if (mesg==NULL) return NULL;

	pp = (char*)malloc((strlen(mesg)+1)*2);
	if (pp==NULL) return NULL;

	i = j = 0;
	while(mesg[i]!='\0') {
		if (mesg[i]==CHAR_CR) {
			pp[j++] = '\\';
			pp[j++] = 'r';
		}
		else if (mesg[i]==CHAR_LF) {
			pp[j++] = '\\';
			pp[j++] = 'n';
		}
		else {
			pp[j++] = mesg[i];
		}
		i++;
	}
	pp[j] = '\0';
	
	return pp;
}




/** 
char*  replace_str(char* buf, int len, const char* frm, const char* tos)

buf̕ frm tosŒuD

bufɂ͏\ȗ̈悪Ȃ΂ȂȂDfrm bufƃ̈悪dȂĂ͂ȂD@n
sꍇ NULLԂCbuf̓e͕ωȂD

@param[in]  buf  Ώۂ̕
@param[out] buf  ϊꂽ
@param      len  buf̗̈̑傫ij
@param      frm  ϊ镶
@param      tos  ϊ̕

@return buf ւ̃|C^Dsꍇ NULLDfreeĂ͂ȂD
*/
char*  replace_str(char* buf, int len, const char* frm, const char* tos)
{
	char* wrk = NULL;
    int i, j, k, slen, flen, tlen;

    if (buf==NULL || frm==NULL || tos==NULL) return NULL;

	wrk = (char*)malloc(len);
	if (wrk==NULL) return NULL;

    slen = (int)strlen(buf);
    flen = (int)strlen(frm);
    tlen = (int)strlen(tos);

    i = j = 0;
    while (i<slen && j<len) {
        if (!strncmp((const char*)(buf+i), frm, flen)){
			for (k=0; k<tlen; k++) {
				wrk[j+k] = tos[k];
			}
            i += flen;
            j += tlen;
        }
        else {
            wrk[j++] = buf[i++];
        }
    }

	//
	if (j>=len) {
		free(wrk);
		return NULL;
	}

	wrk[j] = '\0';
	for (k=0; k<=j; k++) buf[k] = wrk[k];
	free(wrk);

    return buf;
}




/**
char*  cut_str(char* buf, int ls, int le)

buf[ls] ` buf[le] ؂oăɊi[ĕԂD
Ԃꂽf[^ free()KvD

@param  buf  Ώۂ̕
@param  ls   ؂oJn̈ʒu
@param  le   ؂oÏʒu

@return ؂oDv free
*/
char*  cut_str(char* buf, int ls, int le)
{
	int   i, len;
	char* ret;

	if (buf==NULL) return NULL;

	ls  = Max(ls, 0);
	le  = Min(le, (int)strlen((const char*)buf)); 
	len = le - ls + 1;
	if (len<=0) return NULL;

	ret = (char*)malloc(len+1);
	if (ret==NULL) return NULL;
	memset(ret, 0, len+1);

	for (i=0; i<len; i++) ret[i] = buf[i+ls];

	return ret;
}




/**
char*  dup_str(char* buf)

 buf̕oDԂꂽf[^ free()KvD

@param  buf  Rs[̕
@return ꂽDv free
*/
char*  dup_str(char* buf)
{
	int   len;
	char* ret;

	if (buf==NULL) return NULL;

	len = (int)strlen(buf);
	ret = (char*)malloc(len+1);
	if (ret==NULL) return NULL;

	memcpy(ret, buf, len);
	ret[len] = '\0';

	return ret;
}




static char _ToSTR[LDATA];		///< Ɨpiϊj


/**
char*  itostr(int n)

int^ n𕶎ɂĕԂD

@param  n  ɕϊl
@return ϊꂽDfree Ă͂ȂD
*/
char*  itostr(int n)
{
	memset(_ToSTR, 0, LDATA);
	snprintf(_ToSTR, LDATA-1, "%d", n);
	return _ToSTR;
}




/**
char*  ltostr(long int n)

long int^ n𕶎ɂĕԂD

@param  n  ɕϊl
@return ϊꂽDfree Ă͂ȂD
*/
char*  ltostr(long int n)
{
	memset(_ToSTR, 0, LDATA);
	snprintf(_ToSTR, LDATA-1, "%ld", n);
	return _ToSTR;
}




/**
char*  ultostr(unsigned long int n)

unsigned long int^ n𕶎ɂĕԂD

@param  n  ɕϊl
@return ϊꂽDfree Ă͂ȂD
*/
char*  ultostr(unsigned long int n)
{
	memset(_ToSTR, 0, LDATA);
	snprintf(_ToSTR, LDATA-1, "%ld", n);
	return _ToSTR;
}




/**
char*  ftostr(float n)

float^ n𕶎ɂĕԂD

@param  n  ɕϊl
@return ϊꂽDfree Ă͂ȂD
*/
char*  ftostr(float n)
{
	memset(_ToSTR, 0, LDATA);
	snprintf(_ToSTR, LDATA-1, "%f", n);
	return _ToSTR;
}




/**
int  count_lines(char* buf)

f[^ buf̍s𐔂D
s '\0' łĂ 1sƐ

@param buf s𐔂镶f[^
@return sD
*/
int  count_lines(char* buf)
{
	int i    = 0;
	int line = 0;
	
	if (buf==NULL) return 0;
	line++;

	while(buf[i]!='\0') {
		if (buf[i]==CHAR_CR) {
			line++;
			if (buf[i+1]==CHAR_LF) i++;
		}
		else if (buf[i]==CHAR_LF) {
			line++;
		}
		i++;
	}

	return line;
}




/**
int hexstr2i(const char* str)

16i̕𐮐ɕϊD

󔒂͖D󔒈ȊO16iłȂoCŕϊ~߂

@param  str  ɕϊ 16i̕ 
@return ϊꂽ
*/
int hexstr2i(const char* str)
{
	int i, ret = 0;
	if (str==NULL) return ret;

	int len = (int)strlen(str);

	for (i=0; i<len; i++) {
		if (str[i]>='0' && str[i]<='9') {
			ret = ret*16;
			ret += (int)(str[i] - '0');
		}
		else if (str[i]>='A' && str[i]<='F') {
			ret = ret*16;
			ret += (int)(str[i] - 'A') + 10;
		}
		else if (str[i]>='a' && str[i]<='f') {
			ret = ret*16;
			ret += (int)(str[i] - 'a') + 10;
		}
		else if (str[i]!=' ') {
			break;
		}
	}

	return ret;
}





/* ************************************************************************* */

#ifndef WIN32

/**
void  init_rand(void)

/dev/urandom 痐̌n

/dev/urandom ǂ߂Ȃꍇ́CĂяoꂽ̎(b)ɂė̌nD

@attention Windows ł͎gpłȂ
*/
void  init_rand(void)
{
	FILE* fp;
	unsigned int seed;

	fp = fopen("/dev/urandom", "rb");
	if (fp==NULL) {
		srand(time(NULL));
		return;
	}
	fread(&seed, sizeof(unsigned int), 1, fp);
	fclose(fp);

	srand(seed);
}

#endif




/**
char*  randstr(int n)

_ A-Za-z0-9 ܂ł̕ nD
Ԃꂽf[^ free()KvD

@param  n  o͂镶D
@return _ɐꂽ n̕Dv free
*/
char*  randstr(int n)
{
	char   base[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
	char*  pass;
	int	i, sz;

	if (n<=0) return NULL;
	pass = (char*)malloc(n+1);
	if (pass==NULL) return pass;

	sz = (int)strlen(base);
	for (i=0; i<n; i++) pass[i] = base[rand()%sz];
	pass[n] = '\0';

	return pass;
}




/**
unsigned char*  randbit(int n)

_ n bit̃oCi𐶐D
Ԃꂽf[^ free()KvD

@param  n  o͂ bitD
@return _ɐꂽ n bit̃f[^Dv free
*/
unsigned char*  randbit(int n)
{
	int   i, sz;
	unsigned char* bin;

	sz = (n+7)/8;
	bin = (unsigned char*)malloc(sz);
	if (bin==NULL) return NULL;

	memset(bin, 0, sz);
	for (i=0; i<n; i++) setBit(bin, i, rand()%2);

	return bin;	
}






/* ************************************************************************* */

/** void  swap_byte(void* p, int s, int c)

ʃoCgƉʃoCgtɂD

pw s̃f[^ coCgÂtɂD

@param[in,out] p  f[^ւ̃|C^D
@param         s  f[^̒DoCgPʁD
@param         c  tɂf[^̒DoCgPʁD
*/
void  swap_byte(void* p, int s, int c)
{
	int	i;
	uByte* u = (uByte*)p;
	for (i=0; i<s; i+=c) reverse_str(&u[i], c);
}



	
/**
short  swaps(short p)

short^i16bitjp̏㉺8bitւD
ntohs(), htons()̑֊֐DWindowspD

@param  p  ւl
@return ̒l
*/
short  swaps(short p)
{
	short  r;
    uByte* t;
	uByte* f;
     
	t = (uByte*)&r;
	f = (uByte*)&p;
	t[0] = f[1];
	t[1] = f[0];

	return r;
}



/** int  swapl(int p)

int^ 32bit p8bitÂtɂ

ntohl(), htonl()̑֊֐DWindowspD

@param  p  ւl
@return ̒l
*/
int  swapl(int p)
{
	int    r;
    uByte* t;
	uByte* f;
     
	t = (uByte*)&r;
	f = (uByte*)&p;
	t[0] = f[3];
	t[1] = f[2];
	t[2] = f[1];
	t[3] = f[0];

	return r;
}




/**
void  reverse_str(uByte* p, int s)

oCgtɂD

@param[in,out] p  oCgf[^ւ̃|C^D
@param s oCgf[^̒D
*/
void  reverse_str(uByte* p, int s)
{
	int	i;
	uByte  c;
	 
	if (s<=0) s = (int)strlen((const char*)p);

	for (i=0; i<s/2; i++) {
		c		= p[s-1-i];
		p[s-1-i] = p[i];
		p[i]	 = c;
	}
}   




/* ************************************************************************* */

/**
int  file_from_to(char* src, char* dst, char* mode)

modeɏ],t@C src dstɃRs[D

@param  src   Rs[(\[X)t@C
@param  dst   Rs[(fBXeBl[V)t@C
@param  mode  Rs[t@C̃I[v[hDfopenɓD"rwa"

@retval  1    I
@retval -1    ƗpȂD
@retval -2    \[Xt@C݂ȂD(V{bNN~)
@retval -3    \[Xt@C̃I[vs
@retval -4    fBXeBl[Vt@C̃I[vs
 */
int  file_from_to(char* src, char* dst, char* mode)
{
	long int  sz;
	unsigned char* buf;
	FILE*  fp;

	sz = file_size(src);
	if (sz<0) return -2;
	buf = (unsigned char*)malloc(sz);
	if (buf==NULL) return -1;

	fp = fopen(src, "rb");
	if (fp==NULL) {
		free(buf);
		return -3;
	}
	fread(buf, sz, 1, fp);
	fclose(fp);

	fp = fopen(dst, mode);
	if (fp==NULL) {
		free(buf);
		return -4;
	}
	fwrite(buf, sz, 1, fp);
	fclose(fp);

	free(buf);
	return sz;
}




/**
int  fp_from_to(FILE* src, FILE* dst, long int sz)

t@C src dstɃRs[D

@param  src  Rs[(\[X)̃t@C|C^
@param  dst  Rs[(fBXeBl[V)̃t@C|C^
@param  sz   Rs[(\[X)̃TCY

@retval  1   I
@retval -1   ƗpȂD
@retval -2   t@CTCY̎w肪D
@retval -3   \[Xt@C̃I[vsD
@retval -4   fBXeBl[Vt@C̃I[vsD
 */
int  fp_from_to(FILE* src, FILE* dst, long int sz)
{
	unsigned char* buf;
	if (sz<=0)     return -2;
	if (src==NULL) return -3;
	if (dst==NULL) return -4;

	buf = (unsigned char*)malloc(sz);
	if (buf==NULL) return -1;

	fread(buf, sz, 1, src);
	sz = (int)fwrite(buf, sz, 1, dst);

	free(buf);
	return sz;
}




/**
char* get_file_name(char* str)

tpXt@Cւ̃|C^oD

@param  str  t@C̃tpX
@return str̃t@Cւ̃|C^
*/
char* get_file_name(char* str)
{
	int   sz, len;
	char* fnm;

	if (str==NULL) return NULL;

#ifdef WIN32
	char  cc = '\\';
#else
	char  cc = '/';
#endif

	len = (int)strlen(str);
	sz  = 0;
	while (sz<len && str[len-1-sz]!=cc) sz++;
	fnm = str + len - sz; 

	return fnm;
}




/**
char* get_file_extension(char* str)

tpXt@C̊gqւ̃|C^oD

@param  str  t@C̃tpX
@return str̃t@C̊gqւ̃|C^
*/
char* get_file_extension(char* str)
{
	int   sz, len;
	char* ext;

	if (str==NULL) return NULL;

	char  pd = '.';

#ifdef WIN32
	char  cc = '\\';
#else
	char  cc = '/';
#endif

	len = (int)strlen(str);
	sz  = 0;
	while (sz<len && str[len-1-sz]!=cc && str[len-1-sz]!=pd) sz++;

	if (str[len-1-sz]!=pd) return NULL;
	ext = str + len - sz; 

	return ext;
}




/**
unsigned long int   file_size(char* fn)											  

ʏ̃t@C̑傫ԂDV{bNNȂǂ 0D

@param  fn  t@C
@return t@C̃TCY
 */
unsigned long int   file_size(char* fn)											  
{									  
	struct stat stbuf;											   
																   
	stat(fn, &stbuf);

#ifdef WIN32
	return stbuf.st_size;
#else
	if (S_ISREG(stbuf.st_mode)) return stbuf.st_size;
	else						return 0;
#endif
}




/**
int  file_exist(char* fn)

w肵t@C݂ēǂݍ݉\ł΁u^vłȂ΁uUvԂD

t@CxI[vĊmF̂ŁCԂ|D
ǂݍ݉\ȃt@CmF̂ł΁Cfile_size()̕iԂjD

@param  fn    t@C
@retval TRUE  t@C݂,ǂ݂݉\D
@retval FALSE t@C݂Ȃ,܂͓ǂ݂ݕs\D 
*/
int  file_exist(char* fn)
{
	FILE* fp;

	if (fn==NULL) return FALSE;

	if ((fp=fopen(fn,"rb"))==NULL) {
		return FALSE;
	}
	fclose(fp);
	return TRUE;
}




/**
FILE*  file_chmod_open(char* fn, char* fm, mode_t mode)

w肵t@C݂ēǂݍ݉\ł΁Cmode ֕ύXC

t@C fm[hŃI[vȂāCt@C|C^ԂD@n
݂Ȃ΁Ct@C쐬đύXČCt@C fm[hŃI[vȂāC
t@C|C^ԂD@n
̎w@ɂĂ man 2 chmod QƂ邱ƁD

@param fn        t@C
@param fm        t@C[hC"r","w","a".....
@param mode      Dsee...  man 2 chmod

@retval NULLȊO I[vt@C|C^
@retval NULL     sD 
 */
FILE*  file_chmod_open(char* fn, char* fm, mode_t mode)
{
	FILE* fp;

	if (!file_exist(fn)) {
		if ((fp=fopen(fn,"wb"))==NULL) return NULL;
		fclose(fp);
	}

#ifndef WIN32
	fp = NULL;
	if (chmod(fn, mode)) return fp;
#endif

	fp = fopen(fn, fm);
	return fp;
}




/**
char*  temp_filename(char* dir, int flen)

/dev/urandom 𗘗pčƗpt@C̃_ȃt@C𓾂D

/dev/urandom ǂ߂Ȃꍇ randstr() 𗘗pD
Ԃꂽf[^ free()KvD

@param  dir   ƃt@CfBNg
@param  flen  t@C̒
@return Ɨpt@C̃tpXDv free
 */
char*  temp_filename(const char* dir, int flen)
{
	FILE* fp;
	int   i, dlen=0;
	char  nostr = '\0';
	char* fname;
	char* fnbin;
	char* fnb64;

	if (dir==NULL) dir = &nostr;
	dlen = (int)strlen(dir);
	if (flen<=0)   flen = 15;

	fname = (char*)malloc(dlen+flen+1);
	if (fname==NULL) return NULL;
	fnbin = (char*)malloc(flen);
	if (fnbin==NULL) {
		free(fname);
		return NULL;
	}

	fnb64 = NULL;
	fp = fopen("/dev/urandom", "rb");

	do {
		if (fp!=NULL) {
			fread(fnbin, flen, 1, fp);
			fnb64 = (char*)encode_base64((unsigned char*)fnbin, flen);
			if (fnb64!=NULL) fnb64[flen] = '\0';
		}
		if (fnb64==NULL) fnb64 = randstr(flen);

		for (i=0; i<flen; i++) {
			if (fnb64[i]=='/') fnb64[i] = 'x';
			if (fnb64[i]=='+') fnb64[i] = 'X';
		}

		memset (fname, 0, dlen+flen+1);
		strncpy(fname, dir, dlen);
		strncat(fname, fnb64, flen);
		free(fnb64);
	} while(file_exist(fname)); 

	if (fp!=NULL) fclose(fp);
	free(fnbin);
	return fname;
}




unsigned char*  read_file(char* fname, unsigned long int* size)
{
	if (size==NULL) return NULL;

	*size = file_size(fname);
	if (*size<=0) return NULL;

	unsigned char* buf = (unsigned char*)malloc(*size);
	if (buf==NULL) return NULL;

	FILE* fp  = fopen(fname, "rb");
	if (fp==NULL) {
		free(buf);
		return NULL;
	}

	fread(buf, *size, 1, fp);
	fclose(fp);

	return buf;
}




long int  write_file(char* fname, unsigned char* buf, unsigned long int size)
{
	if (size==0) return 0;

	FILE* fp  = fopen(fname, "wb");
	if (fp==NULL) return 0;

	fwrite(buf, size, 1, fp);
	fclose(fp);

	return size;
}




/**
char* double_bs(char* str) 

񒆂 obNXy[X @\ 2d @\@\ ɕςԂD
Ԃꂽf[^ free()KvD

@param  str  Ώۂ̕
@return ϊꂽDsꍇ NULLDv free
*/
char* double_bs(char* str) 
{
	int  i, j;
	int  len, bsn=0;
	char* buf;

	len = (int)strlen(str);
	for (i=0; i<len; i++) if (str[i]=='\\') bsn++;
	buf = (char*)malloc(len+bsn+1);
	if (buf==NULL) return NULL;

	for (i=0,j=0; i<len; i++) {
		buf[j++] = str[i];
		if (str[i]=='\\') buf[j++] = '\\';
	}
	buf[j] = '\0';

	return buf;
}




/**
char*  numbering_name(char* fmt, int n)

tH[}bg fmtɏ]āCn܂ޕoD
Ԃꂽf[^ free()KvD

@param  fmt  tH[}bgpDex. "%d %f\n" see printf()
@param  n    ɕϊ鐮D

@return o͂ꂽDv free
@see printf()
*/
char*  numbering_name(char* fmt, int n)
{
    int    len;
    char   fname[LNAME], *fo;

	memset(fname, 0, LNAME);
	snprintf(fname, LNAME-1, fmt, n);
	len = (int)strlen(fname);

	fo = (char*)malloc(len + 1);
	if (fo==NULL) return NULL;

	memset(fo, 0, len+1);
    strncpy(fo, fname, len);
    return fo;
}





/* ************************************************************************* */

/**
void kanji_convert(unsigned char* mesg)

ϐ KnjiCodeɏ]ĊR[hϊD

@param[in,out] mesg  ϊ镶 unsigned char*^f[^DeD

@attention ݂ KanjiCode SJIS̏ꍇ̂ EUC SJISɕϊD
@see KanjiCode
 */
void kanji_convert(unsigned char* mesg)
{
	if (KanjiCode==CODE_SJIS) {
		kanji_convert_euc2sjis(mesg);
	}
}




/**
void kanji_convert_euc2sjis(unsigned char* mesg)

EUCSJISɕϊD

@param[in,out] mesg  ϊ镶 unsigned char*^f[^DeD
*/
void kanji_convert_euc2sjis(unsigned char* mesg)
{
	int i = 0;
	while(mesg[i]!='\0' && mesg[i+1]!='\0'){
		if (mesg[i]>=0xa1 && mesg[i]<=0xfe){ // EUC
			euc2sjis(&mesg[i], &mesg[i+1]);
			i = i + 2;
		} 
		else  i++;
	}
}




/**
void kanji_convert_sjis2euc(unsigned char* mesg)

SJISEUCɕϊD

@param[in,out] mesg  ϊ镶 unsigned char*^f[^DeD
*/
void kanji_convert_sjis2euc(unsigned char* mesg)
{
	int i = 0;
	while(mesg[i]!='\0' && mesg[i+1]!='\0'){
		// ifϑIȂ̂́CRpCŌxo邽   (GCC) 3.3.2 20031218 
		if ((mesg[i]>=0x81 && mesg[i]<=0x9f) ||
			(mesg[i]>=0xe0 && mesg[i]<=0xfe) || mesg[i]==0xff) { // SJIS
			sjis2euc(&mesg[i], &mesg[i+1]);
			i = i + 2;
		} 
		else  i++;
	}
}




/**
void  euc2sjis(unsigned char *c1, unsigned char *c2)

R[hϊDEUCSJIS
  
@param[in,out] c1  ϊ镶̑oCgDeD
@param[in,out] c2  ϊ镶̑oCgDeD
*/
void  euc2sjis(unsigned char *c1, unsigned char *c2)
{
	if (*c1%2==0) *c2 -= 0x02;
	else{
		*c2 -= 0x61;
		if (*c2>0x7e) (*c2)++;
	}

	if (*c1<0xdf) {
		(*c1)++;
		*c1 /= 2;
		*c1 += 0x30;
	}
	else {
		(*c1)++;
		*c1 /= 2;
		*c1 += 0x70;
	}
}




/**
void  sjis2euc(unsigned char *c1, unsigned char *c2)

R[hϊDSJISEUC

@param[in,out] c1  ϊ镶̑oCgDeD
@param[in,out] c2  ϊ镶̑oCgDeD
*/
void  sjis2euc(unsigned char *c1, unsigned char *c2)
{
	if (*c2<0x9f) {
		if (*c1 < 0xa0) {
			*c1 -= 0x81;
			*c1 *= 2;
			*c1 += 0xa1;
		}
			
		else {
			*c1 -= 0xe0;
			*c1 *= 2;
			*c1 += 0xdf;
		}
		if (*c2>0x7f) (*c2)--;
		*c2 += 0x61;
	}
	else {
		if (*c1<0xa0) {
			*c1 -= 0x81;
			*c1 *= 2;
			*c1 += 0xa2;
		}
		else {
			*c1 -= 0xe0;
			*c1 *= 2;
			*c1 += 0xe0;
		}
		*c2 += 2;
	 }
}




/**
void  upper_string(char* str)

stȑ啶ɕϊ

@param[in,out] str  ϊ镶ւ̃|C^DeD
*/
void  upper_string(char* str)
{
	int  i;
	for (i=0; i<(int)strlen((const char*)str); i++) {
		if (str[i]>='a' && str[i]<='z') str[i] += 'A' - 'a';
	}
}




/**
unsigned char*  decode_base64(unsigned char* buf, int* sz)

buf base64fR[hD

ϊ buf̐擪珇sDA-Za-z0-9+/ ȊO͖(ႦΉsR[h)D@n
̓obt@ 4byte(6bit*4)̏ꍇ, o̓obt@ 3byte(8bit*3)ƂȂD
̓obt@̃oCg 4̔{łȂꍇ(sȃf[^), Ȃ̓obt@ɂ '='}Ă̂Ƃ݂ȂD

Ԃꂽf[^ free()KvD

@param         buf  base64fR[h镶D
@param[in,out] sz   in:  sz fR[hꂽf[^̒i[ intւ̃|C^Di
                    out: fR[hꂽf[^̃TCY
@return base64fR[hꂽf[^Dv free

@par 
@code
	"QQ" fR[h 'A',0x00 ƂȂD
@endcode
*/
unsigned char*  decode_base64(unsigned char* buf, int* sz)
{
	int   i, j, cc=0, bas, lt;
	unsigned char* dcd;

	lt = 0;
	while (buf[lt]!='=' && lt<(int)strlen((const char*)buf)) {
		lt++;
		if (lt==(int)strlen((const char*)buf)) break;
	}
	*sz = lt/4*3 + (lt%4)*3/4;
	dcd = (unsigned char*)malloc(*sz);
	if (dcd==NULL) return dcd;
	memset(dcd, 0, *sz);

	for (i=0; i<lt; i++) {
		if	    (buf[i]>='A' && buf[i]<='Z') cc = buf[i] - 'A';
		else if (buf[i]>='a' && buf[i]<='z') cc = buf[i] - 'a' + 26;
		else if (buf[i]>='0' && buf[i]<='9') cc = buf[i] - '0' + 52;
		else if (buf[i]=='+')				 cc = 62;
		else if (buf[i]=='/')				 cc = 63;

		if (cc<64) {
			bas = 32;
			for (j=0; j<6; j++) {
				setBit(dcd, i*6+j, cc/bas);
				cc = cc%bas;
				bas = bas/2;
			}
		}
	}

	return dcd;
}




/**
unsigned char*  encode_base64(unsigned char* buf, int sz)

oCif[^ buf base64ɃGR[hD

̓obt@ 3byte(8bit*3)̏ꍇ, o̓obt@ 4byte(6bit*4)ƂȂD
̓obt@ 6bitEłȂꍇ, 6bitE ܂ 0tꂽƌD@n
o̓obt@ 4byteEłȂꍇ, 4byteE܂ '='tďo͂D 
܂,o̓obt@ł 60bytẻs͍sȂD@n
ʂ n byte ͂ꂽꍇ, base64̏o͂̕ (n+2)/3*4 byte ƂȂD

Ԃꂽf[^ free()KvD

@param  buf  base64ɃGR[hf[^D
@param  sz   f[^̒D-1ȉ̏ꍇ buf ͕Ƃ݂ȂD
@return base64ɃGR[hꂽDv free

@par 
@code
	'A',0x00,0x01 𕶎(sz=1)Ƃ݂Ȃĕ "QQ==" ƂȂD
	'A',0x00,0x01  3byte𕄍(sz=3) "QQAB" ƂȂD
@endcode
*/
unsigned char*  encode_base64(unsigned char* buf, int sz)
{
	unsigned char  base[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	unsigned char  bas;
	int   i, j, len;
	unsigned char*  ecd;
	
	if (buf==NULL) return NULL;
   	if (sz<0) len = (int)strlen((const char*)buf);
	else  	  len = sz;
	if (len==0) return NULL;

	sz  = (len + 2)/3*4;
	ecd = (unsigned char*)malloc(sz+1);
	if (ecd==NULL) return NULL;
	memset(ecd, 0, sz+1);

	for (i=0; i<sz; i++) {
		bas = 0x00;
		if (len*8 > i*6) {
			for (j=0; j<6; j++) {
				if (len*8 > i*6+j) setBit(&bas, j+2, getBit(buf, i*6+j));
				//else			   setBit(&bas, j+2, 0);
			}
			ecd[i] = base[(int)bas];
		}
		else {
			ecd[i] = '=';
		}
	}

	return ecd;
}




/**
unsigned char*  decode_urlenc(unsigned char* buf, int* sz)

buf  URLGR[hfR[hD
Ԃꂽf[^ free()KvD

@param	    buf  fR[h镶D
@param[out] sz   fR[hꂽf[^̒i[ϐD
@return fR[hꂽf[^Dv free
*/
unsigned char*  decode_urlenc(unsigned char* buf, int* sz)
{
	int	i, j, len;
	unsigned char*  dec;

	if (buf==NULL) return NULL;
	len = (int)strlen((const char*)buf) + 1;
	dec = (unsigned char*)malloc(len);
	if (dec==NULL) return NULL;
	memset(dec, 0, len);

	i = j = 0;
	while (buf[i]!='\0') {
		if (buf[i]=='%') {
			if (buf[i+1]=='\0') return dec;
			if (buf[i+2]=='\0') return dec;
			dec[j++] = decode_hex(buf[i+1], buf[i+2]);
			i += 2;
		}
		else {
			if (buf[i]=='+') dec[j++] = ' ';
			else			 dec[j++] = buf[i];
		}
		i++;
	}

	*sz = j;
	return dec;
}
				



/**
unsigned char*  encode_urlenc(unsigned char* buf)

oCif[^ buf URLGR[hD

GR[hȂɂĂ͐FXl邪Cő񐔓IɍlẴvOł͈ȉ̂悤ɂD@n
GR[hȂ  0-9, A-Z, a-z, -._

Ԃꂽf[^ free()KvD

@param  buf  GR[hf[^D
@param  sz   GR[hf[^̒D-1ȉ̏ꍇ buf ͕Ƃ݂ȂD
@return GR[hꂽDv free
*/
unsigned char*  encode_urlenc(unsigned char* buf, int sz)
{
	int	i, j, len;
	unsigned char*  enc;


	if (sz<0) sz = (int)strlen((const char*)buf);
	len = sz*3 + 1;
	enc = (unsigned char*)malloc(len);
	if (enc==NULL) return NULL;
	memset(enc, 0, len);

	for(i=0, j=0; i<sz; i++) {
		if (buf[i]==' ') {										// pXy[X
			enc[j++] = '+';
		}
		else if ((buf[i]>=0x30 && buf[i]<=0x39) ||				// 0-9
				 (buf[i]>=0x41 && buf[i]<=0x5a) ||				// A-Z
				 (buf[i]>=0x61 && buf[i]<=0x7a) ||				// a-z
				  buf[i]=='-' || buf[i]=='.' || buf[i]=='_'){	// - . _
			enc[j++] = buf[i];
		}
		else {
			unsigned char* asc = encode_hex(buf[i]);
			if (asc==NULL) {
				free(enc);
				return NULL;
			}
			enc[j++] = '%';
			enc[j++] = asc[0];
			enc[j++] = asc[1];
			free(asc);
		}
	}

	return enc;
}	




/**
unsigned char*  decode_quoted_printable(unsigned char* buf, int* sz)

buf  quoted printablefR[hD
Ԃꂽf[^ free()KvD

@param      buf  fR[h镶D
@param[out] sz   fR[hꂽf[^̒i[ϐD
@return fR[hꂽf[^
*/
unsigned char*  decode_quoted_printable(unsigned char* buf, int* sz)
{
	int	i, j, len;
	unsigned char*  dec;

	len = (int)strlen((const char*)buf) + 1;
	dec = (unsigned char*)malloc(len);
	if (dec==NULL) return NULL;
	memset(dec, 0, len);

	i = j = 0;
	while (buf[i]!='\0') {
		if (buf[i]=='=') {
			if (buf[i+1]=='\0') return dec;
			if (buf[i+2]=='\0') return dec;
			dec[j++] = decode_hex(buf[i+1], buf[i+2]);
			i += 2;
		}
		else {
			if (buf[i]=='_') dec[j++] = ' ';			// RFC2047
			else			 dec[j++] = buf[i];
		}
		i++;
	}

	*sz = j;
	return dec;
}




/**
unsigned char*  encode_quoted_printable(unsigned char* buf, int sz)

oCif[^ buf quoted printable ɃGR[hD

RFC2047 ɏ]C' '  '_' ɃGR[hD@n
GR[hȂ '=', '_' ȊO 0x21-0x7e @n
GR[h镶   '=', '_', 0x00-0x20, 0x7f-0xff

Ԃꂽf[^ free()KvD

@param  buf  GR[hf[^D
@param  sz   GR[hf[^̒D-1ȉ̏ꍇ buf ͕Ƃ݂ȂD
@return GR[hꂽDv free
*/
unsigned char*  encode_quoted_printable(unsigned char* buf, int sz)
{
	int	i, j, len;
	unsigned char*  enc;

	if (sz<0) sz = (int)strlen((const char*)buf);
	len = sz*3 + 1;
	enc = (unsigned char*)malloc(len);
	if (enc==NULL) return NULL;
	memset(enc, 0, len);

	for (i=0, j=0; i<sz; i++) {
		if (buf[i]=='=') {		// 0x3d
			enc[j++] = '=';
			enc[j++] = '3';
			enc[j++] = 'D';
		}
		else if (buf[i]=='_') {		// 0x5f
			enc[j++] = '=';
			enc[j++] = '5';
			enc[j++] = 'F';
		}
		else if (buf[i]==' ') {		// 0x20  RFC2047
			enc[j++] = '_';
		}
		else if (buf[i]<=0x1f || buf[i]>=0x7f) {
			unsigned char* asc = encode_hex(buf[i]);
			if (asc==NULL) {
				free(enc);
				return NULL;
			}
			enc[j++] = '=';
			enc[j++] = asc[0];
			enc[j++] = asc[1];
			free(asc);
		}
		else {
			enc[j++] = buf[i];
		}
	}

	return enc;
}	




/**
unsigned char*  encode_hex(unsigned char cc)

LN^16iR[h̕ɕϊD
Ԃꂽf[^ free()KvD

@param cc ϊLN^D

@return Vmۂꂽ 3bytë̗
@return [0]  16iR[h̏4BitD 0-9,A-F
@return [1]  16iR[h̉4BitD 0-9,A-F
@return [2]  '\0'
@retval NULL sD

@par 
@code
	encode_hex(' ')   "20" ԂD
@endcode
*/
unsigned char*  encode_hex(unsigned char cc)
{
	unsigned char* ret;
	unsigned char  pp1, pp2;
	unsigned char  base[] = "0123456789ABCDEF";

	ret = (unsigned char*)malloc(3);
	if (ret==NULL) return NULL;

	pp1 = cc >> 4;
	pp2 = cc & 0x0f;

	ret[0] = base[pp1];
	ret[1] = base[pp2];
	ret[2] = '\0';

	return ret;
}




/**
unsigned char  decode_hex(unsigned char pp1, unsigned char pp2)

16iR[hLN^ɕϊDO-9,A-FȊOw肳ꂽꍇ0Ƃ݂ȂD

@param  pp1  16iR[h̏4BitD 0-9,A-F
@param  pp2  16iR[h̉4BitD 0-9,A-F
@return w肳ꂽASCIIR[h̃LN^

@code
Fdecode_hex('2', '0')   ' ' ԂD
@endcode
*/
unsigned char  decode_hex(unsigned char pp1, unsigned char pp2)
{
	unsigned char ret;

	if (pp1>=0x30 && pp1<=0x39) 	 pp1 -= 0x30;	// 0-9
	else if (pp1>=0x41 && pp1<=0x46) pp1 -= 0x37;	// A-F
	else if (pp1>=0x61 && pp1<=0x66) pp1 -= 0x57;	// a-f
	else 							 pp1 =  0x00;

	if (pp2>=0x30 && pp2<=0x39) 	 pp2 -= 0x30;	// 0-9
	else if (pp2>=0x41 && pp2<=0x46) pp2 -= 0x37;	// A-F
	else if (pp2>=0x41 && pp2<=0x46) pp2 -= 0x57;	// a-f
	else 							 pp1 =  0x00;

	ret = (pp1<<4) + pp2;
	return ret;
}





//////////////////////////////////////////////////////////////////////////////////////////////////////
//
//

/**
void  print_message(const char* fmt, ...)

obt@ÕbZ[Wóistderrj

@param  fmt  o̓tH[}bgDprintf() ɏD
@see printf()
*/
void  print_message(const char* fmt, ...)
{
	char*  nfmt;
	int    len;

	va_list  args;
	va_start(args, fmt);

	len  = (int)strlen(fmt);	
	nfmt = (char*)malloc(len + 1);
	if (nfmt==NULL) return;

	strncpy(nfmt, fmt, len);
	nfmt[len] = '\0';

	vfprintf(stderr, nfmt, args); 
	fflush(stderr);
	free(nfmt);

	va_end(args);

	return;
}




/**
void  fprint_message(FILE *fp, const char* fmt, ...)

obt@ÕbZ[Wo

@param  fp   o͐̃t@C|C^
@param  fmt  o̓tH[}bgDprintf() ɏD
@see printf()
*/
void  fprint_message(FILE* fp, const char* fmt, ...)
{
	char*  nfmt;
	int    len;

	va_list  args;
	va_start(args, fmt);

	len  = (int)strlen(fmt);	
	nfmt = (char*)malloc(len + 1);
	if (nfmt==NULL) return;

	strncpy(nfmt, fmt, len);
	nfmt[len] = '\0';

	vfprintf(fp, nfmt, args); 
	fflush(fp);
	free(nfmt);

	va_end(args);

	return;
}




/**
void  print_escape(char* fmt, char* mesg)

GXP[v܂ރbZ[W̏óD(stderr)

݂ CR, LF ̂ @\r, @\n ɕϊDsee change_esc()

@param  fmt   o̓tH[}bgDprintf() ɏD
@param  mesg  GXP[v܂ޕD
@see change_esc(), printf()
*/
void  print_escape(char* fmt, char* mesg)
{
	char* pp;

	if (fmt==NULL || mesg==NULL) return;
	
	pp = change_esc(mesg);
	if (pp==NULL) return;

	print_message(fmt, pp);
	free(pp);
}




/**
void  fprint_escape(FILE* fp, char* fmt, char* mesg)

GXP[v܂ރbZ[W̏óD

݂ CR, LF ̂ @\r, @\n ɕϊD

@param  fp    o͐̃t@C|C^
@param  fmt   o̓tH[}bgDprintf() ɏD
@param  mesg  GXP[v܂ޕD

@see change_esc(), printf()
*/
void  fprint_escape(FILE* fp, char* fmt, char* mesg)
{
	char* pp;

	if (fmt==NULL || mesg==NULL) return;
	
	pp = change_esc(mesg);
	if (pp==NULL) return;

	fprint_message(fp, fmt, pp);
	free(pp);
}




/**
void  fdump(FILE* fp, unsigned char* mesg, int n)

fobOp 16i_vóD

mesg noCg16i\Dn<0 ̏ꍇ Ƃ݂ȂD

@param  fp    o͂t@Cւ̃|C^DNULL̏ꍇ stderr
@param  mesg  \f[^D
@param  n     \oCg
*/
void  fdump(FILE* fp, unsigned char* mesg, int n)
{
	int  i, j, mod, len;
	char ascii[16];

	if (fp==NULL) fp = stderr;

	if (mesg==NULL) {
		fprintf(fp, "(Dump Data is NULL)\n");
		return;
	}

    if (n<0) len = (int)strlen((const char*)mesg);
    else     len = n;

    memset(ascii, 0x2e, 16);
    for (i=0, j=0; i<len; i++) {
        fprintf(fp, "%02x ", mesg[i]);
        if (mesg[i]>=0x20 && mesg[i]<=0x7e) ascii[j] = mesg[i];
		j++;
        if (j==16) {
            fprintf(fp, "   ");
            for (j=0; j<16; j++) {
                fprintf(fp, "%c ", ascii[j]);
            }
            fprintf(fp, "\n");
            memset(ascii, 0x2e, 16);
            j = 0;
        }
    }
                
    mod = len%16;
    if (mod>0) {                           
        for (i=0; i<17-mod; i++) fprintf(fp, "   ");
        for (i=0; i<mod; i++)    fprintf(fp, "%c ", ascii[i]);
    }                    
    fprintf(fp, "\n");
}




/**
void  print_16x(FILE* fp, unsigned char* mesg, int n)

fobOp 16isóD

mesg noCg16isC󔒂Ȃŕ\Dn<0 ̏ꍇ Ƃ݂ȂD

@param  fp    o͂t@Cւ̃|C^DNULL̏ꍇ stderr
@param  mesg  \f[^D
@param  n     \oCg
*/
void  print_16x(FILE* fp, unsigned char* mesg, int n)
{
	int  i, len;

	if (fp==NULL) fp = stderr;

    if (n<0) len = (int)strlen((const char*)mesg);
    else     len = n;

    for (i=0; i<len; i++) {
        fprintf(fp, "%02x", mesg[i]);
    }
    fprintf(fp, "\n");
}






/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  oCg^ Oobt@
//

/**
ringbuffer*  new_ringbuffer()

̃Oobt@^ϐoD̑ł́C܂obt@͍쐬ȂD
Ԃꂽf[^ free()KvD

@return ̃Oobt@ϐDv free
@see ringbuffer, del_ringbuffer()
*/
ringbuffer*  new_ringbuffer()
{
	ringbuffer* rb;
	
	rb = (ringbuffer*)malloc(sizeof(ringbuffer));
	if (rb==NULL) return NULL;
	memset(rb, 0, sizeof(ringbuffer));

	return rb;
}




/**
void   del_ringbuffer(ringbuffer** rb)

new_ringbuffer()ōoOobt@폜D

@param[in,out] rb  in: 폜郊Oobt@|C^ւ̃|C^Dout: *rb NULLɂȂD
@see rigbuffer, new_ringbuffer()
*/
void   del_ringbuffer(ringbuffer** rb)
{
	if (rb!=NULL && *rb!=NULL) {
		freeNull((*rb)->buf);
		free(*rb);
		*rb = NULL;
	}
}




/**
ringbuffer   init_ringbuffer()

ꂽ ringbufferϐԂD

@return ꂽ ringbufferϐ
@see ringbuffer
*/
ringbuffer   init_ringbuffer()
{
	ringbuffer  rb;

	memset(&rb, 0, sizeof(ringbuffer));
	//rb.bufsz = -1;

	return rb;
}




/**
ringbuffer   make_ringbuffer(int sz)

obt@݂郊Oobt@oD
obt@ free()KvD

@param  sz  Oobt@̃obt@̃TCY
@return 쐬ꂽ ringbufferϐDobt@ v free
*/
ringbuffer   make_ringbuffer(int sz)
{
	ringbuffer  rb;

	memset(&rb, 0, sizeof(ringbuffer));
	
	if (sz>0) {
		rb.buf = (unsigned char*)malloc(sz);
		if (rb.buf==NULL) return rb;
		memset(rb.buf, 0, sz);
		rb.bufsz = sz;
	}

	return rb;
}




/**
void   free_ringbuffer(ringbuffer* rb)

Oobt@̃obt@JD

@param  rb  Oobt@ւ̃|C^
*/
void   free_ringbuffer(ringbuffer* rb)
{
	if (rb!=NULL) {
		freeNull(rb->buf);
		memset(rb, 0, sizeof(ringbuffer));
	}
}




/**
void   clear_ringbuffer(ringbuffer* rb)

Oobt@ rb ̃f[^NAijD

@param  rb  Oobt@ւ̃|C^
*/
void   clear_ringbuffer(ringbuffer* rb)
{
	if (rb!=NULL) {
		int sz = rb->bufsz;
		unsigned char* ptr = rb->buf;
		memset(rb->buf, 0, rb->bufsz);
		memset(rb, 0, sizeof(ringbuffer));
		rb->buf   = ptr;
		rb->bufsz = sz;
	}
}




/**
int   put_ringbuffer(ringbuffer* rb, unsigned char* pp, int sz)

Oobt@ rb փf[^ szoCgi[D

@param[in]  rb  bZ[WXg[ւ̃|C^D
@param[out]	rb  @b state 0: obt@͐ԁD-1: obt@ُ͈ȏԂɂD
@param      pp  i[f[^ւ̃|C^D
@param      sz  i[f[^̃TCYiBytej

@retval  0ȏ  񂾃oCgD
@retval	-1      NULL̃f[^D
@retval	-2      obt@if[^i[j̗̈悪ȂD
@retval	-3      obt@if[^i[j̑傫ȂDf[^putȂD
*/
int   put_ringbuffer(ringbuffer* rb, unsigned char* pp, int sz)
{
	if (rb==NULL) return -1;
	rb->state = 0;

	if (pp==NULL)      return -1;
	if (rb->buf==NULL) return -2;
	if (rb->datasz+sz>rb->bufsz) {
		rb->state = -1;
		return -3;
	}

	if (rb->epoint+sz<=rb->bufsz) {
		memcpy(&((rb->buf)[rb->epoint]), pp, sz);
		rb->epoint = rb->epoint + sz;
		if (rb->epoint==rb->bufsz) rb->epoint = 0;
	}
	else {
		memcpy(&(rb->buf[rb->epoint]), pp, rb->bufsz-rb->epoint);
		memcpy(rb->buf, &(pp[rb->bufsz-rb->epoint]), sz-(rb->bufsz-rb->epoint));
		rb->epoint = rb->epoint + sz - rb->bufsz; 
	}

	rb->datasz += sz;
	return sz;
}	




/**
unsigned char*   get_ringbuffer(ringbuffer* rb, int sz)

Oobt@ rb  szoCg̃f[^oD
Ԃꂽf[^ free()KvD

@param[in]  rb   Oobt@ւ̃|C^
@param[out] rb   @b state 0: obt@͐ԁD-1: obt@ُ͈ȏԂɂD
@param      sz   ooCgD

@retval NULLȊO of[^ւ̃|C^Dv  free
@retval	NULL     f[^擾sDݗLȃf[^TCYsz菬D܂͒PɎsD
*/
unsigned char*   get_ringbuffer(ringbuffer* rb, int sz)
{
	unsigned char* pp;

	if (rb==NULL) return NULL;
	rb->state = 0;
	if (rb->buf==NULL) return NULL;
	if (sz>rb->datasz) return NULL;

	pp = (unsigned char*)malloc(sz+1);
	if (pp==NULL) {
		rb->state = -1;
		return NULL;
	}
	memset(pp, 0, sz+1);

	if (rb->spoint+sz<=rb->bufsz) {
		memcpy(pp, &(rb->buf[rb->spoint]), sz);
		rb->spoint = rb->spoint + sz;
		if (rb->spoint==rb->bufsz) rb->spoint = 0;
	}
	else {
		memcpy(pp, &(rb->buf[rb->spoint]), rb->bufsz-rb->spoint);
		memcpy(&(pp[rb->bufsz-rb->spoint]), rb->buf, sz-(rb->bufsz-rb->spoint));
		rb->spoint = rb->spoint + sz - rb->bufsz; 
	}

	rb->datasz -= sz;
	return pp;
}	





///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// oCg^ bZ[WXg[obt@
//

/**
int   put_mstream(mstream* sb, unsigned char* mesg)

bZ[WijXg[ sb փbZ[Wïꕔji[D@n
ŁCbZ[WƂ @\r@\n, @\r ܂ @\n ŋ؂Ă镶ł̂ƂłD

@param[in]  sb    bZ[WXg[ւ̃|C^
@param[out] sb    @b state  0: Xg[͐ԁD-1: Xg[ُ͈ȏԂɂD
@param      mesg  i[郁bZ[WC܂͂̈ꕔ

@retval  0ȏ    񂾃oCgiCRLF܂ށj
@retval	-1        NULL̃f[^D
@retval	-2        obt@if[^i[j̗̈悪ȂD
@retval	-3        obt@if[^i[j̑傫ȂD
*/
int   put_mstream(mstream* sb, unsigned char* mesg)
{
	int  i, n, m, cc, np=0, len;

	if (sb==NULL)   return -1;
	sb->state = 0;
	if (mesg==NULL) return -1;
	if (sb->buf==NULL) return -2;

	len = (int)strlen((const char*)mesg);
	for (i=0, n=0, m=0; i<len; i++) {
		if (mesg[i]==CHAR_LF || (mesg[i]==CHAR_CR && mesg[i+1]!=CHAR_LF)) {
			if (m==0) m = i;
			n++;
		}
	}
	if (sb->datano==0 && n>=1) np = (sb->epoint + m + 1) % sb->bufsz;

	cc = put_ringbuffer(sb, mesg, len);
	if (cc>=0) {
		if (sb->datano==0 && n>=1) sb->npoint = np;
		sb->datano += n;
	}

	if (cc<0) sb->state = -1;
	return cc;
}




/**
unsigned char*  get_mstream(mstream* sb)

bZ[WijXg[ sb 玟̃bZ[WoDsR[h͍폜D@n
ŁCbZ[WƂ @\r@\n, @\r ܂ @\n ŋ؂Ă镶ł̂ƂłD

@param[in]  sb   bZ[WXg[ւ̃|C^
@param[out] sb   @b state  0: Xg[͐ԁD-1: Xg[ُ͈ȏԂɂDij

@retval NULLȊO oXg[f[^ւ̃|C^Dv free
@retval NULL     f[^擾sDݗLȃbZ[Wf[^͖D܂͒PɎsD
*/
unsigned char*  get_mstream(mstream* sb)
{
	int  n, len;
	unsigned char* pp;

	if (sb==NULL) return NULL;
	sb->state = 0;
	if (sb->buf==NULL) return NULL;
	if (sb->datano==0) return NULL;

	len = sb->npoint - sb->spoint;
	if (len==0) return NULL;
	else if (len<0) len += sb->bufsz;

	pp = get_ringbuffer(sb, len);
	if (pp==NULL) {
		sb->state = -1;
		return NULL;
	}
	chomp((char*)pp);

	sb->datano += -1;
	sb->spoint = sb->npoint;

	if (sb->datano>=1) {
		int m;
		n = sb->spoint;
		while (n!=sb->epoint) {
			m = (n + 1) % sb->bufsz;
			if (sb->buf[n]==CHAR_LF || (sb->buf[n]==CHAR_CR && sb->buf[m]!=CHAR_LF)) {
				sb->npoint = m;
				break;
			}
			n = m;
		}
	}

	return pp;
}




/**
unsigned char*  fgets_mstream(unsigned char* mesg, mstream* sb)

bZ[WXg[̃bZ[WisjoD

bZ[W mesg ̓bZ[WXg[ɈUobt@OC̊֐ɂsǂݏoD
ʂԂ鎞Cs̉sR[h͍폜Csɂ͕K \0 D@n
bZ[WXg[̃obt@mۂĂȂꍇ́CŏɌĂяoꂽ_ŊmۂD
Ů֐gpāCMf[^obt@OCŌ܂œǂݎɂ͕KXg[gp
̊֐Ăяo΂΂ȂȂDŖꍇ͎Mf[^͕̐ۏ؂ȂD

@param      mesg  obt@ɈUi[郁bZ[WDNULLłD
@param[in]  sb    Xg[obt@iOobt@^̃Xg[obt@jD
@param[out] sb    @b buf obt@mۂĂȂ΁CIɊmۂD
@param[out] sb    @b state : bZ[WXg[쒆ُ͈ȏԂɂD
@param[out] sb    @b state 1:    bZ[WXg[ɗLȃf[^ȂDreturn  NULL

@return oւ̃|C^
*/
unsigned char*  fgets_mstream(unsigned char* mesg, mstream* sb)
{
	int state=0;
	unsigned char* pp;

	if (sb==NULL) return NULL;
	if (sb->buf==NULL) {
		*sb = make_mstream(RECVBUFSZ);
		if (sb->buf==NULL) return NULL;
	}

	if (mesg!=NULL) put_mstream(sb, mesg);
	if (sb->state<0) state = sb->state;

	if (sb->datano==0) {
		sb->state = 1;
		return NULL;
	}
	pp = get_mstream(sb);
	
	if (sb->state>=0 && state<0) sb->state = state;
	return pp;
}





///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// 
//

/**
unsigned char*  uuid2guid(unsigned char* p)

oCi UUID  eLXgGUIDɕϊDv free()

@param  p oCi UUID. 128bit
@return eLXg GUID. v free
*/
unsigned char*  uuid2guid(unsigned char* p)
{
    unsigned char* guid;

	if (p==NULL) return NULL;

	guid = (unsigned char*)malloc(LGUID);	// 40 = 32+4+1(\0) + 
	if (guid==NULL) return NULL;

    snprintf((char*)guid, 37, "%02x%02x%02x%02x-%02x%02x-%02x%02x-%02x%02x-%02x%02x%02x%02x%02x%02x",
                    p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7],p[8],p[9],p[10],p[11],p[12],p[13],p[14],p[15]);

    return guid;
}




/**
unsigned char*  guid2uuid(unsigned char* p)

eLXgGUID oCiUUID ɕϊDv free @n
͂ GUIĎ`łȂ́Cʂ͕ۏ؂ȂD

@param  p  eLXg GUID
@return oCi UUIDւ̃|C^D128bit. v free
*/
unsigned char*  guid2uuid(unsigned char* p)
{
	int   i, j;
    unsigned char* uuid;

	if (p==NULL) return NULL;

	uuid = (unsigned char*)malloc(16);
	if (uuid==NULL) return NULL;

	i = j = 0;
	while (p[i]!='\0' && j<16) {
		if (p[i]!='-' && p[i+1]!='\0') {
			unsigned char hb, lb;

			if      (p[i]>='0' && p[i]<='9')     hb = p[i] - '0';
			else if (p[i]>='a' && p[i]<='f')     hb = p[i] - 'a' + 10;
			else if (p[i]>='A' && p[i]<='F')     hb = p[i] - 'A' + 10;
			else hb = '\0';

			if      (p[i+1]>='0' && p[i+1]<='9') lb = p[i+1] - '0';
			else if (p[i+1]>='a' && p[i+1]<='f') lb = p[i+1] - 'a' + 10;
			else if (p[i+1]>='A' && p[i+1]<='F') lb = p[i+1] - 'A' + 10;
			else lb = '\0';
			
			uuid[j] = (hb<<4) + lb;
			i++;
			j++;
		}
		i++;
	}

    return uuid;
}






///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// VOi
//
#ifndef WIN32

#ifdef SIGCHLD

/**
void  set_sigterm_child(void (*handler)(int))

child vZXȈݒD

@param  (*handler)()  `ChvZXIɌĂяo֐ւ̃|C^

@attention
VOi֌W̊֐ Windowsł͎gpłȂ
*/
void  set_sigterm_child(void (*handler)(int))
{    
	struct sigaction sa;

	if (handler!=NULL) sa.sa_handler = handler;
	else               sa.sa_handler = sigterm_child;

	sa.sa_flags = SA_NOCLDSTOP | SA_RESTART; 
    sigemptyset(&sa.sa_mask);
	sigaddset(&sa.sa_mask, SIGINT);
	sigaddset(&sa.sa_mask, SIGHUP);
	sigaddset(&sa.sa_mask, SIGTERM);
    sigaction(SIGCHLD, &sa, NULL);
}




/**
void  set_sigsegv_handler(void (*handler)(int))

ZOe[VG[̃nhݒD@n
 NULLw肵ꍇ́Cnh֐Ƃ trap_segmentation_falt() gpD

@param  (*handler)()  ZOe[VG[ɌĂяo֐ւ̃|C^
@see trap_segmentation_falt()
*/
void  set_sigsegv_handler(void (*handler)(int))
{
	struct sigaction sa;

	if (handler!=NULL) sa.sa_handler = handler;
	else               sa.sa_handler = trap_segmentation_falt;
	
	sa.sa_flags = 0;
	sigemptyset(&sa.sa_mask);
	sigaction(SIGSEGV, &sa, NULL);
}




/**
void  trap_segmentation_falt(int signal)

ZOe[VG[ɃftHgŌĂяo֐D

@param  signal  nh̃VOiԍDVXeɂĐݒ肳D
*/
void  trap_segmentation_falt(int signal)
{
	print_message("****************************************************************\n");
	print_message("* Segmentation Falt in [%d] !!!!!\n", getpid());
	print_message("****************************************************************\n");

	exit(signal);
}




/**
void  ignore_sigterm_child()

Ȍ child vZX̏I𖳎D
*/
void  ignore_sigterm_child()
{    
	struct sigaction sa;

	sa.sa_handler = SIG_IGN;
	sa.sa_flags   = 0; 
    sigemptyset(&sa.sa_mask);
    sigaction(SIGCHLD, &sa, NULL);
}




/**
void  sigterm_child(int signal)

child vZXȈ

@param  signal  nh̃VOiԍDVXeɂĐݒ肳D
*/
void  sigterm_child(int signal)
{
    pid_t pid = 0;
    int ret;

	DEBUG_MESG("%d is waiting for children. signal = %d\n", getpid(), signal);

    do {	// `ChvZX̏I҂	
        pid = waitpid(-1, &ret, WNOHANG);
    } while(pid>0);
}


#endif		// SIGCHLD

#endif		// NOT WIN32






///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// for Windows
//

#ifdef WIN32

/* see common.h

void  bzero(char* p, unsigned int n)
{
	for (unsigned int i=0; i<n; i++) *(p++) = 0x00;
}



void  bcopy(char* f, char* t, unsigned int n)
{
	for (unsigned int i=0; i<n; i++) *(t++) = *(f++);
}
*/

#endif   // WIN32
