// SetDevice.cpp : t@C
//

#include "stdafx.h"

#include "resource.h"
#include "SetDevice.h"


// CSetDevice _CAO

IMPLEMENT_DYNAMIC(CSetDevice, CDialog)

//CSetDevice::CSetDevice(NiSDK_Lib lib, CParameterSet prm, CWnd* pParent /*=NULL*/)
CSetDevice::CSetDevice(CExNiDevice* dev, CParameterSet prm, CWnd* pParent /*=NULL*/)
	: CDialog(CSetDevice::IDD, pParent)
{
//	sdk_lib = lib;
	nidev	= dev;
	param   = prm;

	crntLibEitBox	= NULL;
	openniButton	= NULL;
	kinectButton	= NULL;
	useLEDButton    = NULL;
	useMotorButton  = NULL;
}



void CSetDevice::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CSetDevice, CDialog)
END_MESSAGE_MAP()




// CSetDevice bZ[W nh

BOOL CSetDevice::OnInitDialog()
{
	CDialog::OnInitDialog();

	crntLibEitBox  = (CEdit*)  GetDlgItem(IDC_INFO_CRNT_LIB);
	openniButton   = (CButton*)GetDlgItem(IDC_RADIO_LIB_OPENNI);
	kinectButton   = (CButton*)GetDlgItem(IDC_RADIO_LIB_KINECT);
	useLEDButton   = (CButton*)GetDlgItem(IDC_CHECK_LED_CONTROL);
	useMotorButton = (CButton*)GetDlgItem(IDC_CHECK_MOTOR_CONTROL);

	if (nidev->nowSDKLib==NiSDK_OpenNI) {
		crntLibEitBox->SetWindowText(_T("OpenNI"));
	}
	else if (nidev->nowSDKLib==NiSDK_Kinect) {
		crntLibEitBox->SetWindowText(_T("Kinect SDK"));
	}
	else {
		crntLibEitBox->SetWindowText(_T(""));
	}


	if (param.nextSDKLib==NiSDK_OpenNI) {
		openniButton->SetCheck(1);
		kinectButton->SetCheck(0);
	}
	else if (param.nextSDKLib==NiSDK_Kinect) {
		openniButton->SetCheck(0);
		kinectButton->SetCheck(1);
	}

	if (param.useDevLED)   useLEDButton->SetCheck(1);
	else                   useLEDButton->SetCheck(0);
	if (param.useDevMotor) useMotorButton->SetCheck(1);
	else                   useMotorButton->SetCheck(0);


	//
	if (!nidev->enableUSBDev || nidev->nowSDKLib==NiSDK_None) {
		useLEDButton->SetCheck(0);
		useLEDButton->EnableWindow(FALSE);
		useMotorButton->SetCheck(0);
		useMotorButton->EnableWindow(FALSE);
	}
	else if (nidev->nowSDKLib==NiSDK_Kinect) {
		useLEDButton->SetCheck(0);
		useLEDButton->EnableWindow(FALSE);
	}

	return TRUE;
}



void CSetDevice::OnOK()
{
	if (openniButton->GetCheck())      param.nextSDKLib = NiSDK_OpenNI;
	else if (kinectButton->GetCheck()) param.nextSDKLib = NiSDK_Kinect;

	if (useLEDButton->GetCheck())   param.useDevLED   = TRUE;
	else                            param.useDevLED   = FALSE;	
	if (useMotorButton->GetCheck()) param.useDevMotor = TRUE;
	else                            param.useDevMotor = FALSE;

	CDialog::OnOK();
}


