#pragma once


#include  "ParameterSet.h"




//////////////////////////////////////////////////////////////////////////////////////////
// 
// CSetMotion _CAO
//

class CSetMotion : public CDialog
{
	DECLARE_DYNAMIC(CSetMotion)


public:
	CSetMotion(CParameterSet prm, UINT id, CWnd* pParent=NULL);
	virtual ~CSetMotion() {}

	CParameterSet getParameter(void) { return param;}


protected:
	CParameterSet param;
};





//////////////////////////////////////////////////////////////////////////////////////////
// 
// CSetOpenNIMotion _CAO
//

class CSetOpenNIMotion : public CSetMotion
{
	DECLARE_DYNAMIC(CSetOpenNIMotion)

public:
	CSetOpenNIMotion(CParameterSet prm, CWnd* pParent=NULL);   // WRXgN^
	virtual ~CSetOpenNIMotion() {}

	// _CAO f[^
	enum { IDD = IDD_SETMOTION_OPENNI };


protected:
	CButton*	 posButton;
	CButton*	 rotButton;

	CSliderCtrl* cnfdncSldr;
	CEdit*		 cnfdncEBox;

	CButton*	 jntButton;

	CButton*	 niteSmthBtn;
	CSliderCtrl* smoothSldr;
	CEdit*		 smoothEBox;

	CButton*	 maSmthBtn;
	CComboBox*	 maTypeCombo;
	CComboBox*	 maNumCombo;

	CSliderCtrl* YaxisSldr;
	CEdit*		 YaxisEBox;

	CComboBox*	 partsCombo;

	float	confidence;
	float   smoothNITE;
	float	YaxisCrrct; 


protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
protected:
	virtual void OnOK();
public:
	afx_msg void OnChangeConfidence();
	afx_msg void OnChangeSmooth();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnCheckNiteSmooth();
	afx_msg void OnCheckMvavSmooth();
	afx_msg void OnChangeYRot();
};






//////////////////////////////////////////////////////////////////////////////////////////
// 
// CSetKinectMotion _CAO
//

class CSetKinectMotion : public CSetMotion
{
	DECLARE_DYNAMIC(CSetKinectMotion)

public:
	CSetKinectMotion(CParameterSet prm, CWnd* pParent=NULL);   // WRXgN^
	virtual ~CSetKinectMotion() {}

	// _CAO f[^
	enum { IDD = IDD_SETMOTION_KINECT };


protected:
	CButton*	 jntButton;

	CButton*	 knctSmthBtn;
	CSliderCtrl* smoothSldr;
	CEdit*		 smoothEBox;
	CSliderCtrl* crrctnSldr;
	CEdit*		 crrctnEBox;

	CButton*	 maSmthBtn;
	CComboBox*	 maTypeCombo;
	CComboBox*	 maNumCombo;

	CSliderCtrl* YaxisSldr;
	CEdit*		 YaxisEBox;

	CComboBox*	 partsCombo;

	float	correction;
	float   smoothKNCT;
	float	YaxisCrrct; 


protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
protected:
	virtual void OnOK();
public:
	afx_msg void OnChangeCorrection();
	afx_msg void OnChangeSmooth();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnCheckKinectSmooth();
	afx_msg void OnCheckMvavSmooth();
	afx_msg void OnChangeYRot();
};


