#pragma once


#include  "KinectWin.h"
#include  "ExNiJoints.h"
#include  "ExNiFileDev.h"





class  CExKinectWin : public CKinectWin
{
public:
	CExKinectWin(void);
	virtual ~CExKinectWin(void);

public:
	CExNiFileDev*	niFileDev;
	CExportNiData*	niExportData;

	CNiJoints*		niJoints;
	CExNiNetwork*		niNetwork;
	CExNiSHMemory*		sharedMem;

	CParameterSet	appParam;

	CExTextFrame*	pLogFrame;
	CExFrame*		pSensorFrame;
	CExFrame*		pSkeletonFrame;
	CLogWndDoc*		pLogDoc;



public:
	BOOL			dataSaving;

	Vector<double>	vect_fwrd;


public:
	void	setSensorFramePtr(CExFrame* pfrm)   { pSensorFrame = pfrm;}
	void	setSkeletonFramePtr(CExFrame* pfrm) { pSkeletonFrame = pfrm;}
	void	setLogFramePtr(CExTextFrame* pfrm);
	void	setParameter(CParameterSet param);
	
	void	nop(void) { m_err_mesg = _T("No Operation with Kinect SDK!!");}


public:
	void	convertPos2JointsData(void);
	void	convertUpperPos2JointsData(void);


public:
	virtual void saveJointsData(void);
	virtual void logingJointsData(void);
	
	virtual void checkGroundLevel(void) { if (appParam.useJointConst) niJoints->CheckGroundLevel(m_ground_level);}
	virtual void checkBoneLength(void)  { if (appParam.useJointConst) niJoints->CheckBoneLength();}
	virtual void convertJointsData(void);

	virtual void lostTrackingUser(int uid);  //   { DEBUG_ERR("LOST   TRACKING USER (%d)", uid);}
	virtual void detectTrackingUser(int uid);  // { DEBUG_ERR("DETECT TRACKING USER (%d)", uid);}
};






UINT  kinectEventLoop(LPVOID pParam);

